build.sh 11 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304
  1. #!/bin/bash
  2. # (c) 2014-2016 Freifunk Hochstift <kontakt@hochstift.freifunk.net>
  3. #
  4. # This script builds the firmware by the environment variables given, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  10. #
  11. # optional:
  12. # AUTOUPDATER = force Autoupdater Branch (stable/testing/experimental/off)
  13. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  14. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  15. # CLEAN = 'dirclean' to perform "make dirclean" before build or 'clean' to perform "make clean" (default: 'none')
  16. # KEY_DIR = specify directory for gluon-opkg-key
  17. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  18. # PRIORITY = determines the number of day a rollout phase should last at most
  19. # PUBLISH = 0 (default) or 1, publish firmware at the end
  20. # SITE_ID = specific site repository commit-id (leave blank to use HEAD)
  21. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  22. # VERBOSE = 0 (default) or 1, call the make commands with 'V=s' to see actual errors better
  23. # VERSIONS_DIR = specify directory for version files
  24. #
  25. ### includes
  26. . functions.sh
  27. ### static variables
  28. MY_DIR=$(dirname $0)
  29. MY_DIR=$(readlink -f "${MY_DIR}")
  30. DEFAULT_KEY_DIR="${MY_DIR}/opkg-keys"
  31. DEFAULT_VERSIONS_DIR="${MY_DIR}/versions"
  32. CODE_DIR="${MY_DIR}/src"
  33. GLUON_BUILD_DIR="${CODE_DIR}/build"
  34. SITE_DIR="${CODE_DIR}/site"
  35. PATCH_DIR="${SITE_DIR}/patches"
  36. OUTPUT_DIR="${MY_DIR}/output"
  37. IMAGE_DIR="${CODE_DIR}/output/images"
  38. MODULE_DIR="${CODE_DIR}/output/modules"
  39. MANIFEST_DIR="${CODE_DIR}/output/images/sysupgrade"
  40. SITE_GEN_SCRIPT="${CODE_DIR}/packages/ffho/ffho/ffho-site-generate/scripts/gen-site-conf.lua"
  41. SRV_URL="firmware.in.ffho.net"
  42. SRV_USER="firmware"
  43. SRV_PATH="/srv/firmware"
  44. BUILD_INFO_FILENAME="build-info.txt"
  45. SITE_REPO_URL="https://git.ffho.net/freifunkhochstift/ffho-site.git"
  46. LANG=C
  47. pushd ${MY_DIR} > /dev/null
  48. ### set reasonable defaults for unset environment variables
  49. [ -n "${AUTOUPDATER}" ] || AUTOUPDATER=${BRANCH}
  50. if [ -n "${BROKEN}" ]; then
  51. if [ "${BROKEN}" -eq "1" ]; then
  52. export BROKEN
  53. else
  54. unset BROKEN
  55. fi
  56. fi
  57. [ -n "${BUILD_TS}" ] || BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  58. [ -n "${CLEAN}" ] || CLEAN="none"
  59. if [ -n "${KEY_DIR}" ]; then
  60. KEY_DIR=$(readlink -f "${KEY_DIR}")
  61. [ -e "${KEY_DIR}" ] || abort "Can not find specified key directory: ${KEY_DIR}"
  62. else
  63. KEY_DIR="${DEFAULT_KEY_DIR}"
  64. fi
  65. if [ -n "${VERSIONS_DIR}" ]; then
  66. VERSIONS_DIR=$(readlink -f "${VERSIONS_DIR}")
  67. else
  68. VERSIONS_DIR="${DEFAULT_VERSIONS_DIR}"
  69. fi
  70. [ -e "${VERSIONS_DIR}" ] || mkdir -p ${VERSIONS_DIR}
  71. [ "$?" -eq "0" ] || abort "Unable to create versions directory: ${VERSIONS_DIR}"
  72. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  73. [ -n "${PRIORITY}" ] || PRIORITY=0
  74. [ -n "${PUBLISH}" ] || PUBLISH=0
  75. [ -n "${VERBOSE}" ] || VERBOSE=0
  76. MAKE_PARAM=""
  77. [ "${VERBOSE}" -eq "1" ] && MAKE_PARAM="${MAKE_PARAM} V=s"
  78. ### ERROR handling
  79. [ -n "${BASE}" ] || abort "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)."
  80. [ -n "${BRANCH}" ] || abort "Please specify BRANCH environment variable."
  81. [ "${BRANCH}" == "experimental" -o "${BASE}" != "HEAD" ] || abort "HEAD is not an allowed BASE-identifier for non-experimental builds. Either use a tagged commit or the commit-SHA itself."
  82. [ -n "${VERSION}" -o "${BRANCH}" == "experimental" ] || abort "Please specify VERSION environment variable (not necessary for experimental branch)."
  83. [ "${BRANCH}" == "experimental" -o ! -r "${VERSIONS_DIR}/${VERSION}" ] || abort "There exists a version file for '${VERSION}' ... you are trying to do something really stupid, aren't you?"
  84. ### INIT /src IF NECESSARY
  85. if [ ! -d "${CODE_DIR}" ]; then
  86. info "Code directory does not exist yet - fetching Gluon ..."
  87. git clone https://github.com/freifunk-gluon/gluon.git "${CODE_DIR}"
  88. [ "$?" -eq "0" ] || abort "Failed to fetch Gluon repository."
  89. fi
  90. ### INIT /src/site IF NECESSARY
  91. if [ ! -d "${SITE_DIR}" ]; then
  92. info "Site repository does not exist, fetching it ..."
  93. git clone "${SITE_REPO_URL}" "${SITE_DIR}"
  94. [ "$?" -eq "0" ] || abort "Failed to fetch SITE repository."
  95. fi
  96. pushd ${CODE_DIR} > /dev/null
  97. ### CHECKOUT GLUON
  98. progress "Checking out GLUON '${BASE}' ..."
  99. # check if gluon got modified and bail out if necessary
  100. [ "$(git status --porcelain)" ] && abort "Local changes to peers directory. Cowardly refusing to update gluon repository." >&2
  101. git fetch
  102. git checkout -q ${BASE}
  103. [ "$?" -eq "0" ] || abort "Failed to checkout '${BASE}' gluon base version, mimimi." >&2
  104. git show-ref --verify --quiet refs/remotes/origin/${BASE}
  105. if [ "$?" -eq "0" ]; then
  106. git pull
  107. [ "$?" -eq "0" ] || abort "Failed to get newest '${BASE}' in gluon repository, mimimi."
  108. fi
  109. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  110. ### CHECKOUT SITE REPO
  111. progress "Checking out SITE REPO ..."
  112. pushd ${SITE_DIR} > /dev/null
  113. if [ $(git remote | wc -l) -ge "1" ]; then
  114. git fetch
  115. # TODO: check if site got modified locally and bail out if necessary
  116. if [ -z "${SITE_ID}" ]; then
  117. # no specific site given - get the most current one
  118. git checkout -q ${BRANCH}
  119. git branch -r | grep ${BRANCH} > /dev/null
  120. if [ "$?" -eq "0" ]; then
  121. git rebase
  122. [ "$?" -eq "0" ] || abort "Failed to get newest '${BRANCH}' in site repository, mimimi."
  123. fi
  124. else
  125. # fetch site repo updates
  126. git fetch || true
  127. # commit given - use this one
  128. git checkout -q ${SITE_ID}
  129. [ "$?" -eq "0" ] || abort "Failed to checkout requested site commit '${SITE_ID}', mimimi."
  130. fi
  131. fi
  132. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  133. popd > /dev/null #${SITE_DIR}
  134. ### APPLY PATCHES TO GLUON
  135. progress "Applying Patches ..."
  136. git checkout -B patching "${BASE}"
  137. if [ -d "${PATCH_DIR}" -a "$(echo ${PATCH_DIR}/*.patch)" ]; then
  138. git am --whitespace=nowarn ${PATCH_DIR}/*.patch || (
  139. git am --abort
  140. git checkout patched
  141. git branch -D patching
  142. false
  143. )
  144. [ "$?" -eq "0" ] || abort "Failed to apply patches, mimimi."
  145. fi
  146. git branch -M patched
  147. ### DIRCLEAN
  148. if [ -d "${GLUON_BUILD_DIR}/" -a "${CLEAN}" == "dirclean" ]; then
  149. progress "Cleaning your build environment (make dirclean) ..."
  150. make dirclean
  151. fi
  152. ### PREPARE
  153. progress "Preparing the build environment (make update) ..."
  154. make update
  155. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  156. popd > /dev/null #${CODE_DIR}
  157. ### set reasonable defaults for ${TARGETS} and ${BRANCH} if unset
  158. if [ -z "${TARGETS}" ]; then
  159. TARGETS=$(make list-targets | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
  160. info "building all targets: '${TARGETS}'"
  161. fi
  162. if [ "${BRANCH}" == "experimental" -a -z "${VERSION}" ] ; then
  163. VERSION=$(make default-release)
  164. info "EXPERIMENTAL FIRMWARE: using version tag '${VERSION}'"
  165. fi
  166. # we are now ready to produce the firmware images, so let's "save" our state
  167. build_info_path="${VERSIONS_DIR}/${VERSION}"
  168. progress "Saving build information to: ${build_info_path}"
  169. [ -n "${build_info_path}" -a -f "${build_info_path}" ] && rm -f ${build_info_path}
  170. mkdir -p $(dirname ${build_info_path})
  171. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  172. touch $(dirname ${build_info_path})
  173. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  174. echo "VERSION=${VERSION}" >> ${build_info_path}
  175. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  176. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  177. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  178. echo "TARGETS=${TARGETS}" >> ${build_info_path}
  179. echo "TS=${BUILD_TS}" >> ${build_info_path}
  180. ### restore opkg-keys
  181. if [ -e "${KEY_DIR}" ]; then
  182. info "build key already exists, restoring it."
  183. mkdir -p ${GLUON_BUILD_DIR}/
  184. [ "$?" -eq "0" ] || abort "Unable to create directory: ${GLUON_BUILD_DIR}/"
  185. cp -f ${KEY_DIR}/* ${GLUON_BUILD_DIR}/
  186. [ "$?" -eq "0" ] || abort "Unable to copy build key."
  187. fi
  188. ### create site.conf
  189. if [ -x "${SITE_GEN_SCRIPT}" ]; then
  190. progress "Generating defaut site.conf"
  191. eval GLUON_SITEDIR=${SITE_DIR} ${SITE_GEN_SCRIPT}
  192. fi
  193. ### BUILD FIRMWARE
  194. progress "Building the firmware - please stand by!"
  195. pushd ${CODE_DIR} > /dev/null
  196. export GLUON_RELEASE="${VERSION}"
  197. [ "${AUTOUPDATER}" != "off" ] && export GLUON_BRANCH="${AUTOUPDATER}"
  198. for target in ${TARGETS} ; do
  199. # configure build environment for our current target
  200. export GLUON_TARGET="${target}"
  201. # prepare build environment for our current target
  202. progress "${target}: Preparing build environment."
  203. if [ "${CLEAN}" == "clean" ]; then
  204. make clean
  205. [ "$?" -eq "0" ] || abort "${target}: Unable to clean environment."
  206. fi
  207. make -j ${MAKEJOBS} prepare-target ${MAKE_PARAM}
  208. [ "$?" -eq "0" ] || abort "${target}: Unable to build environment."
  209. # need to have a toolchain for the particular target
  210. progress "${target}: Building toolchain."
  211. make -j ${MAKEJOBS} toolchain/install ${MAKE_PARAM}
  212. [ "$?" -eq "0" ] || abort "${target}: Unable to build toolchain."
  213. # now we can start building the images for the target platform
  214. progress "${target}: Building FFHO-flavoured Gluon firmware. You'd better go and fetch some c0ffee!"
  215. make -j ${MAKEJOBS} prepare ${MAKE_PARAM}
  216. [ "$?" -eq "0" ] || abort "${target}: Unable to build firmware."
  217. # finally compile the firmware binaries
  218. progress "${target}: Compiling binary firmware images."
  219. make -j ${MAKEJOBS} images ${MAKE_PARAM}
  220. [ "$?" -eq "0" ] || abort "${target}: Unable to assemble images."
  221. # compile the modules
  222. progress "${target}: Compiling modules."
  223. make -j ${MAKEJOBS} modules ${MAKE_PARAM}
  224. [ "$?" -eq "0" ] || abort "${target}: Unable to build modules."
  225. done
  226. # generate manifest
  227. progress "Generating manifest ..."
  228. GLUON_PRIORITY=${PRIORITY} GLUON_BRANCH=${BRANCH} make manifest
  229. [ "$?" -eq "0" ] || abort "Failed to generate the manifest."
  230. popd > /dev/null #${CODE_DIR}
  231. if [ "${PUBLISH}" -eq "1" ]; then
  232. # copying firmware to the server
  233. if [ -d "${IMAGE_DIR}" ]; then
  234. progress "Copying firmware images ..."
  235. rsync -rlutzc --filter="+ */" --filter="+ *-${VERSION}-*" --filter="- *" -e ssh ${IMAGE_DIR}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}
  236. [ "$?" -eq "0" ] || abort "Failed to copy firmware images."
  237. fi
  238. # copying modules to the server
  239. if [ -d "${MODULE_DIR}" ]; then
  240. progress "Copying modules ..."
  241. MODULE_DIR=$(find ${MODULE_DIR}/ -maxdepth 1 -name *${VERSION})
  242. rsync -rlutzc -e ssh ${MODULE_DIR}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}/modules
  243. [ "$?" -eq "0" ] || abort "Failed to copy modules."
  244. fi
  245. # copy manifest and the build info file
  246. progress "Copying manifest and build info file ..."
  247. pushd ${OUTPUT_DIR} > /dev/null
  248. git fetch
  249. git checkout -q signing
  250. git merge --ff-only origin/master
  251. mkdir -p "${OUTPUT_DIR}/${VERSION}/sysupgrade"
  252. cp -f "${MANIFEST_DIR}/${BRANCH}.manifest" "${OUTPUT_DIR}/${VERSION}/sysupgrade/"
  253. cp -f "${build_info_path}" "${OUTPUT_DIR}/${VERSION}/${BUILD_INFO_FILENAME}"
  254. popd > /dev/null #${OUTPUT_DIR}
  255. # Update symlinks
  256. progress "Update symlink for ${BRANCH}"
  257. pushd ${OUTPUT_DIR} > /dev/null
  258. ln -fsn ${VERSION} ${BRANCH}
  259. popd > /dev/null #${OUTPUT_DIR}
  260. fi
  261. # The end. Finally.
  262. success "We're done, go and enjoy your new firmware (${VERSION})!"
  263. popd > /dev/null #${MY_DIR}